'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TurtleCoinWalletd = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _rpcBuilders = require('./rpcBuilders');

var rpc = _interopRequireWildcard(_rpcBuilders);

var _popsicle = require('popsicle');

var _popsicle2 = _interopRequireDefault(_popsicle);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var TurtleCoinWalletd = exports.TurtleCoinWalletd = function () {
  function TurtleCoinWalletd(host, port, rpcPassword) {
    _classCallCheck(this, TurtleCoinWalletd);

    this.host = host;
    this.port = port;
    this.rpcPassword = rpcPassword;
    this.id = 0;
  }

  _createClass(TurtleCoinWalletd, [{
    key: 'sendXHR',
    value: function sendXHR(payload, success, error) {
      var _this = this;

      return new Promise(function (resolve, reject) {
        var url = _this.host + ':' + _this.port + '/json_rpc',
            id = _this.id;

        console.log('************');
        console.log('Sending HTTP request to walletd JSON-RPC interface at ' + url + '...');
        console.log('Request (id: ' + id + '):');
        console.log(payload);
        console.log('************');

        _popsicle2.default.get(url).then(function (res) {
          console.log('************');
          console.log('Request (id: ' + id + ') to walletd HTTP JSON-RPC interface successful!');
          console.log(res.status);
          console.log(res.body);
          console.log(res.headers);
          console.log('************');

          success ? success(res.body) : resolve(res.body);
        }).catch(function (err) {
          console.log('************');
          console.log('Error sending request (id: ' + id + ')');
          console.log(err);
          console.log('************');

          error ? error(err) : resolve(err);
        });

        _this.id++;
      });
    }
  }, {
    key: 'reset',
    value: function reset(viewSecretKey) {
      return this.sendXHR(rpc.reset(this.id, this.rpcPassword, viewSecretKey ? { viewSecretKey: viewSecretKey } : null));
    }
  }, {
    key: 'save',
    value: function save() {
      return this.sendXHR(rpc.save(this.id, this.rpcPassword));
    }
  }, {
    key: 'getViewKey',
    value: function getViewKey() {
      return this.sendXHR(rpc.getViewKey(this.id, this.rpcPassword));
    }
  }, {
    key: 'getSpendKeys',
    value: function getSpendKeys(address) {
      return this.sendXHR(rpc.getSpendKeys(this.id, this.rpcPassword, { address: address }));
    }
  }, {
    key: 'getStatus',
    value: function getStatus() {
      return this.sendXHR(rpc.getStatus(this.id, this.rpcPassword));
    }
  }, {
    key: 'getAddresses',
    value: function getAddresses() {
      return this.sendXHR(rpc.getAddresses(this.id, this.rpcPassword));
    }
  }, {
    key: 'createAddress',
    value: function createAddress(secretSpendKey, publicSpendKey) {
      return this.sendXHR(rpc.createAddress(this.id, this.rpcPassword, _extends({}, secretSpendKey && { secretSpendKey: secretSpendKey }, publicSpendKey && { publicSpendKey: publicSpendKey })));
    }
  }, {
    key: 'deleteAddress',
    value: function deleteAddress(address) {
      return this.sendXHR(rpc.deleteAddress(this.id, this.rpcPassword, { address: address }));
    }
  }, {
    key: 'getBalance',
    value: function getBalance(address) {
      return this.sendXHR(rpc.getBalance(this.id, this.rpcPassword, address ? { address: address } : null));
    }
  }, {
    key: 'getBlockHashes',
    value: function getBlockHashes(firstBlockIndex, blockCount) {
      return this.sendXHR(rpc.getBlockHashes(this.id, this.rpcPassword, {
        firstBlockIndex: firstBlockIndex,
        blockCount: blockCount
      }));
    }
  }, {
    key: 'getTransactionHashes',
    value: function getTransactionHashes(blockCount, firstBlockIndex, blockHash, addresses, paymentId) {
      return this.sendXHR(rpc.getTransactionHashes(this.id, this.rpcPassword, _extends({
        blockCount: blockCount
      }, firstBlockIndex && { firstBlockIndex: firstBlockIndex }, blockHash && { blockHash: blockHash }, addresses && { addresses: addresses }, paymentId && { paymentId: paymentId })));
    }
  }, {
    key: 'getTransactions',
    value: function getTransactions(blockCount, firstBlockIndex, blockHash, addresses, paymentId) {
      return this.sendXHR(rpc.getTransactions(this.id, this.rpcPassword, _extends({
        blockCount: blockCount
      }, firstBlockIndex && { firstBlockIndex: firstBlockIndex }, blockHash && { blockHash: blockHash }, addresses && { addresses: addresses }, paymentId && { paymentId: paymentId })));
    }
  }, {
    key: 'getUnconfirmedTransactionHashes',
    value: function getUnconfirmedTransactionHashes(addresses) {
      return this.sendXHR(rpc.getUnconfirmedTransactionHashes(this.id, this.rpcPassword, addresses ? { addresses: addresses } : null));
    }
  }, {
    key: 'getTransaction',
    value: function getTransaction(transactionHash) {
      return this.sendXHR(rpc.getTransaction(this.id, this.rpcPassword, { transactionHash: transactionHash }));
    }
  }, {
    key: 'sendTransaction',
    value: function sendTransaction(anonymity, transfers, fee, addresses, unlockTime, extra, paymentId, changeAddress) {
      return this.sendXHR(rpc.sendTransaction(this.id, this.rpcPassword, _extends({
        anonymity: anonymity,
        transfers: transfers,
        fee: fee
      }, addresses && { addresses: addresses }, unlockTime && { unlockTime: unlockTime }, extra && { extra: extra }, paymentId && { paymentId: paymentId }, changeAddress && { changeAddress: changeAddress })));
    }
  }, {
    key: 'createDelayedTransaction',
    value: function createDelayedTransaction() {
      return this.sendXHR(rpc.createDelayedTransaction(this.id, this.rpcPassword, _extends({
        anonymity: anonymity,
        transfers: transfers,
        fee: fee
      }, addresses && { addresses: addresses }, unlockTime && { unlockTime: unlockTime }, extra && { extra: extra }, paymentId && { paymentId: paymentId }, changeAddress && { changeAddress: changeAddress })));
    }
  }, {
    key: 'getDelayedTransactionHashes',
    value: function getDelayedTransactionHashes() {
      return this.sendXHR(rpc.getDelayedTransactionHashes(this.id, this.rpcPassword));
    }
  }, {
    key: 'deleteDelayedTransaction',
    value: function deleteDelayedTransaction(transactionHash) {
      return this.sendXHR(rpc.deleteDelayedTransaction(this.id, this.rpcPassword, { transactionHash: transactionHash }));
    }
  }, {
    key: 'sendDelayedTransaction',
    value: function sendDelayedTransaction(transactionHash) {
      return this.sendXHR(rpc.sendDelayedTransaction(this.id, this.rpcPassword, { transactionHash: transactionHash }));
    }
  }, {
    key: 'sendFusionTransaction',
    value: function sendFusionTransaction(threshold, anonymity, addresses, destinationAddress) {
      return this.sendXHR(this.id, this.rpcPassword, _extends({
        threshold: threshold,
        anonymity: anonymity
      }, addresses && { addresses: addresses }, destinationAddress && { destinationAddress: destinationAddress }));
    }
  }, {
    key: 'estimateFusion',
    value: function estimateFusion(threshold, addresses) {
      return this.sendXHR(this.id, this.rpcPassword, _extends({
        threshold: threshold
      }, addresses && { addresses: addresses }));
    }
  }]);

  return TurtleCoinWalletd;
}();